Attribute VB_Name = "HTMLTableIO"
Option Explicit

Const WidthArrange = 1.5

'IV[g̃tB^HTML\Ƃďo
Sub MakeHtmlFromFilter()
    Dim template_file, output_file As String
    Dim template_stream, output_stream
    Dim html As String
    html = LoadText(ThisWorkbook.path + "\__img\list-template.html")

    If ActiveSheet.AutoFilter Is Nothing Then
        MsgBox ("tB^KpĂ܂")
        Exit Sub
    End If

    html = Replace(html, "<!-- title -->", ActiveSheet.name)
    html = Replace(html, "<!-- thead -->", MakeHtmlTableRows(GetFilterHeader(ActiveSheet)))
    html = Replace(html, "<!-- tbody -->", MakeHtmlTableRows(GetFilterBody(ActiveSheet)))
    html = Replace(html, "/* style-table */", _
        "white-space: nowrap; table-layout: fixed; width: " + _
        CStr(CInt(ActiveSheet.AutoFilter.range.Width * WidthArrange)) + "px;")
    html = Replace(html, "/* style */", MakeHtmlColumnWidthStyle(GetFilterHeader(ActiveSheet)))
    html = Replace(html, "/* style-table-d */", "overflow: hidden; font-size: small;")

    Call SaveText(html, ThisWorkbook.path + "\table-" + CFilePath(ActiveSheet.name) + ".html")
End Sub

Function MakeHtmlColumnWidthStyle(range As range) As String
    Dim c As Long
    MakeHtmlColumnWidthStyle = ""
    For c = 1 To range.Columns.count
        MakeHtmlColumnWidthStyle = MakeHtmlColumnWidthStyle + _
            "table thead tr td:nth-child(" + CStr(c) + ") { width: " + _
            CStr(CInt(range.Cells(1, c).Width * WidthArrange)) + "px; }"
    Next c
End Function

Function MakeHtmlTableRows(range As range) As String
    Dim r, c As Long
    MakeHtmlTableRows = ""

    For r = 1 To range.Rows.count
            MakeHtmlTableRows = MakeHtmlTableRows + "<tr>"
    For c = 1 To range.Columns.count
            MakeHtmlTableRows = MakeHtmlTableRows + "<td>"
            MakeHtmlTableRows = MakeHtmlTableRows + MakeHtmlText(range.Cells(r, c))
            MakeHtmlTableRows = MakeHtmlTableRows + "</td>"
    Next c
            MakeHtmlTableRows = MakeHtmlTableRows + "</tr>"
    Next r
End Function
Function MakeHtmlText(cell As range) As String
    Dim link As Hyperlink
    MakeHtmlText = ""

    MakeHtmlText = CStr(cell.value)
    MakeHtmlText = Replace(MakeHtmlText, "&", "&amp;")
    MakeHtmlText = Replace(MakeHtmlText, "<", "&lt;")
    MakeHtmlText = Replace(MakeHtmlText, ">", "&gt;")
    MakeHtmlText = Replace(MakeHtmlText, "'", "&apos;")
    MakeHtmlText = Replace(MakeHtmlText, """", "&quot;")
    MakeHtmlText = Replace(MakeHtmlText, " ", "&nbsp;")
    MakeHtmlText = Replace(MakeHtmlText, ChrW(160), "&nbsp;")
    For Each link In cell.HyperLinks
        MakeHtmlText = "<a href='" + link.Address + "' target=""_blank"">" + MakeHtmlText + "</a>"
    Next link
End Function
Function GetFilterHeader(sheet As Worksheet) As range
    Set GetFilterHeader = sheet.AutoFilter.range.Resize(1)
End Function
Function GetFilterBody(sheet As Worksheet) As range
    Dim filter_range As range
    Set filter_range = sheet.AutoFilter.range
    Set GetFilterBody = filter_range _
        .Offset(1) _
        .Resize(filter_range.Rows.count - 1, filter_range.Columns.count)
End Function
