Attribute VB_Name = "TextIO"
Option Explicit

Const adSaveCreateNotExist = 1
Const adSaveCreateOverWrite = 2
Const adTypeBinary = 1
Const adTypeText = 2
Const adWriteChar = 0
Const adWriteLine = 1
Const adReadAll = -1
Const adReadLine = -2

Const CR = 13
Const LF = 10
Function LoadText(filePath As String, Optional charSet As String = "UTF-8") As String
With CreateObject("ADODB.Stream")
    .Type = adTypeText
    .charSet = charSet
    .Open
    Call .LoadFromFile(filePath)
    LoadText = .ReadText(adReadAll)
    .Close
End With
End Function
Sub SaveText(text As String, filePath As String, Optional charSet As String = "UTF-8")
    Call CreateDir(DirPath(filePath))
With CreateObject("ADODB.Stream")
    .Type = adTypeText
    .charSet = charSet
    .Open
    Call .WriteText(text, adWriteChar)
    Call .SaveToFile(filePath, adSaveCreateOverWrite)
    .Close
End With
End Sub

Function SplitToLines(text As String) As String()
    Dim i
    Dim lines() As String
    lines = Split(text, Chr(LF))
    For i = LBound(lines) To UBound(lines)
        lines(i) = Replace(lines(i), Chr(CR), "")
    Next i
    SplitToLines = lines
End Function
Function LoadTextLines(filePath As String, Optional charSet As String = "UTF-8") As String()
    Dim text As String
    text = LoadText(filePath, charSet)
    LoadTextLines = SplitToLines(text)
End Function

Function OpenTextFileOnSheet(path As String) As Worksheet
    Dim new_book As Workbook
    Dim target_sheet, new_sheet As Worksheet
    Set target_sheet = ActiveSheet
    Set new_book = Workbooks.Open(target_sheet.Parent.path + "\" + path)
    Set new_sheet = new_book.Sheets(1)
    Call new_sheet.Move(after:=target_sheet)
    Call target_sheet.Select
    Set OpenTextFileAsSheet = target_sheet.Parent.Sheets(target_sheet.index + 1)
End Function

Function SetToColumn(texts() As String, range As range) As range
    Dim i
    For i = 1 To UBound(texts)
        range.Offset(i - 1, 0).Resize(1, 1).value = texts(i)
    Next i
    Set SetToRow = range.Resize(1, UBound(texts))
End Function
Function SetToRow(texts() As String, range As range) As range
    Dim i
    For i = 1 To UBound(texts)
        range.Offset(0, i - 1).Resize(1, 1).value = texts(i)
    Next i
    Set SetToRow = range.Resize(UBound(texts), 1)
End Function

Function ToStrings(range As range) As String()
    Dim i
    Dim c, r As Long
    Dim texts() As String
    ReDim texts(range.count)
    i = 1
    For r = 1 To range.Rows.count
    For c = 1 To range.Columns.count
        texts(i) = CStr(range(r, c).value)
        i = i + 1
    Next c
    Next r
    ToStrings = texts
End Function
Function ToValues(range As range) As Variant()
    Dim i
    Dim c, r As Long
    Dim texts() As Variant
    ReDim texts(range.count)
    i = 1
    For r = 1 To range.Rows.count
    For c = 1 To range.Columns.count
        texts(i) = range(r, c).value
        i = i + 1
    Next c
    Next r
    ToValues = texts
End Function




'₷t@C쐬
Function CFileName(text As String, Optional length As Integer = 128) As String
    CFileName = text
    CFileName = (Replace(CFileName, " ", "_"))
    CFileName = (Replace(CFileName, "/", "_"))
    CFileName = (Replace(CFileName, ":", ""))
    CFileName = (Replace(CFileName, "?", ""))
    CFileName = (Replace(CFileName, """", ""))
    CFileName = (Replace(CFileName, "'", ""))
    
    If length > 0 And Len(CFileName) > length Then
        CFileName = Left(CFileName, length)
    End If
End Function
'Kȃt@CpX쐬
Function CFilePath(path As String, Optional length As Integer = 128) As String
    CFilePath = path
    If Mid(path, 2, 1) = ":" Then
        CFilePath = (Replace(CFilePath, ":", ""))
        CFilePath = Left(CFilePath, 1) + ":" + Mid(CFilePath, 2)
    Else
        CFilePath = (Replace(CFilePath, ":", ""))
    End If
    CFilePath = (Replace(CFilePath, "?", ""))
    CFilePath = (Replace(CFilePath, """", ""))
    CFilePath = (Replace(CFilePath, "'", ""))
    CFilePath = (Replace(CFilePath, "<", ""))
    CFilePath = (Replace(CFilePath, ">", ""))
    CFilePath = (Replace(CFilePath, "*", ""))
    CFilePath = (Replace(CFilePath, "|", ""))

    CFilePath = (Replace(CFilePath, "/", "\"))
    Do While InStr(CFilePath, "\\") > 0
        CFilePath = (Replace(CFilePath, "\\", "\"))
    Loop
    
    If length > 0 And Len(CFilePath) > length Then
        CFilePath = Left(CFilePath, length)
    End If
End Function

Function DirPath(path) As String
    DirPath = Left(path, InStrRev(path, "\"))
    Do While Len(DirPath) > 0 And Right(DirPath, 1) = "\"
        DirPath = Mid(DirPath, 1, Len(DirPath) - 1)
    Loop
End Function
Function ExtensionInPath(path) As String
    Dim dir_index, ext_index As Long
    dir_index = InStrRev(path, "\")
    ext_index = InStrRev(path, ".")
    If ext_index > dir_index Then
        ExtensionInPath = Mid(path, ext_index)
    Else
        ExtensionInPath = ""
    End If
End Function


Sub MoveFile(orig As String, dest As String)
With CreateObject("Scripting.FileSystemObject")

    Call CreateDir(DirPath(dest))
    Call .MoveFile(orig, dest)
    Call DeleteEmptyDir(DirPath(orig))

End With
End Sub
Sub MoveDir(orig As String, dest As String)
    Dim f
With CreateObject("Scripting.FileSystemObject")

    Call CreateDir(DirPath(dest))
    If .FolderExists(dest) Then
        For Each f In .GetFolder(orig).files
            Call MoveFile(f.path, Replace(f.path, orig, dest))
        Next f
    Else
        Call .MoveFolder(orig, dest)
        Call DeleteEmptyDir(DirPath(orig))
    End If

End With
End Sub
Sub DeleteEmptyDir(path As String)
    Dim dir_origin
If Len(path) <= 3 Then
Exit Sub
End If
With CreateObject("Scripting.FileSystemObject")

    Set dir_origin = .GetFolder(path)
    If dir_origin.files.count + dir_origin.SubFolders.count = 0 Then
        dir_origin.Delete
        Call DeleteEmptyDir(DirPath(path))
    End If
End With
End Sub

Function CreateDir(path As String) As String
With CreateObject("Scripting.FileSystemObject")
    path = CFilePath(path)
    If Not .FolderExists(path) Then
        Call .CreateFolder(path)
    End If
    CreateDir = path
End With
End Function
Function CreateFile(path As String) As String
With CreateObject("Scripting.FileSystemObject")
    path = CFilePath(path)
    If Not .FileExists(path) Then
        Call SaveText("", path)
    End If
    CreateFile = path
End With
End Function


Function MatchCount(text As String, pattern As String) As Long
With CreateObject("VBScript.RegExp")
    .pattern = pattern
    .IgnoreCase = False
    .Global = True
    MatchCount = .Execute(text).count
End With
End Function
Function ReplaceByRegex(text As String, pattern As String, replacer As String) As String
With CreateObject("VBScript.RegExp")
    .pattern = pattern
    .IgnoreCase = False
    .Global = True
    ReplaceByRegex = .Replace(text, replacer)
End With
End Function




